clear all;
close all;

global cscale;
global kertype;
global cpar;

% cscale=0.2;
% kertype='imq'; % Basisfunktion
% cscale=0.1;
% kertype='g'; % Basisfunktion
% cscale=20;
% kertype='w2'; % Basisfunktion
cscale=20;
kertype='bes'; % Basisfunktion
cpar=1.5;
hd=0.5;
leblistout=[];
leblistint=[];
nlist=[];
hlist=[];
while 1==1
    [xd,yd]=meshgrid(-1:hd:1,-1:hd:1);
    [nx ny]=size(xd);
    zd=[xd(:),yd(:)];
    [np, nd]=size(zd)
    if np>2000
        break;
    end
    disp('Start forming interpolation system')
    X=kernel(distsq(zd,zd));    
    disp('Start condition estimate')
    cx=condest(X)
    if cx>1.0e14
        break;
    end
    he=hd/6; % Gitterweite, feines Gitter
    [xe,ye]=meshgrid(-1:he:-1+hd,-1:he:-1+hd);
    ze=[xe(:),ye(:)];
    disp('Start forming eval system')
    Xe=kernel(distsq(zd,ze));
    disp('Start solving system')
    Vvale=X\Xe;
    leb=sum(abs(Vvale));
    lebmax=max(leb(:))
    leblistout=[leblistout lebmax];
    
    [xe,ye]=meshgrid(-hd:he:hd,-hd:he:hd);
    ze=[xe(:),ye(:)];
    disp('Start forming eval system')
    Xe=kernel(distsq(zd,ze));
    disp('Start solving system')
    Vvale=X\Xe;
    %    nq=floor(np/2)
    % for i=nq,nq
    %     figure
    % surf(xe,ye,reshape(Vvale(i,:),size(xe)))
    % end
    leb=sum(abs(Vvale));
    lebmax=max(leb(:))
    leblistint=[leblistint lebmax];
    
    nlist=[nlist np];
    hlist=[hlist hd];
%     [xe,ye]=meshgrid(-1:he:1,-1:he:1);
%     ze=[xe(:),ye(:)];
%     disp('Start forming eval system')
%     Xe=kernel(distsq(zd,ze));
%     disp('Start solving system')
%     Vvale=X\Xe;
%     nq=floor(np/2)
%     for i=nq,nq
%         figure
%         surf(xe,ye,reshape(Vvale(i,:),size(xe)))
%         shading interp
%     end
    %     leb=sum(abs(Vvale));
    % 
    %     figure
    %     surf(xe,ye,reshape(leb,size(xe)))
    hd=hd*0.95
    np=ceil(2/hd);
    hd=2/np;
end
% figure
% loglog(hlist, leblistint, hlist,leblistout) 
% title('Lebesgue against h')
% legend('Interior','Corner')
figure
semilogy(nlist,leblistint,nlist,leblistout)
title('Lebesgue against n')
legend('Interior','Corner')
figure
plot(nlist,leblistint./sqrt(nlist),'.',nlist,leblistout./sqrt(nlist),'-')
title('Lebesgue/sqrt(n) against n')
legend('Interior','Corner')
