clear all;
close all;

global cscale;
global kertype;
global cpar;

% cscale=0.2;
% kertype='imq'; % Basisfunktion
% cscale=0.1;
% kertype='g'; % Basisfunktion
% cscale=20;
% kertype='w2'; % Basisfunktion
cscale=20;
kertype='bes'; % Basisfunktion
cpar=1.5;
npp=15 % must be odd
hd=2/(npp-1);

[xd,yd]=meshgrid(-1:hd:1,-1:hd:1);
[nx ny]=size(xd);
zd=[xd(:),yd(:)];
[np, nd]=size(zd)

while 1==1
    disp('Start forming interpolation system')
    X=kernel(distsq(zd,zd));    
    disp('Start condition estimate')
    cx=condest(X)
    if cx>1.0e14
        break;
    end
    he=hd/6; % Gitterweite, feines Gitter
    [xe,ye]=meshgrid(-1:he:1,-1:he:1);
    ze=[xe(:),ye(:)];
    disp('Start forming eval system')
    Xe=kernel(distsq(zd,ze));
    disp('Start solving system')
    Vvale=X\Xe;
    nq=floor(np/2)+1
    for i=nq,nq
        figure
        surf(xe,ye,reshape(Vvale(i,:),size(xe)))
        shading interp
    end
    %     leb=sum(abs(Vvale));
    % 
    %     figure
    %     surf(xe,ye,reshape(leb,size(xe)))
    cscale
    cscale=cscale*2
end
