clear all;
close all;

global cscale;
global kertype;
global cpar;

% cscale=0.2;
% kertype='imq'; % Basisfunktion
% cscale=0.4;
% kertype='g'; % Basisfunktion
% cscale=20;
% kertype='w2'; % Basisfunktion
cscale=320;
kertype='bes'; % Basisfunktion
cpar=1.5;
npp=15 % must be odd
hd=2/(npp-1);

[xd,yd]=meshgrid(-1:hd:1,-1:hd:1);
[nx ny]=size(xd);
zd=[xd(:),yd(:)];
[np, nd]=size(zd)


disp('Start forming interpolation system')
X=kernel(distsq(zd,zd));
disp('Start condition estimate')
cx=condest(X)
he=hd/6; % Gitterweite, feines Gitter
[xe,ye]=meshgrid(-1:he:1,-1:he:1);
ze=[xe(:),ye(:)];
disp('Start forming eval system')
Xe=kernel(distsq(zd,ze));
disp('Start solving system')
Vvale=X\Xe;
leb=sum(abs(Vvale));

figure
surf(xe,ye,reshape(leb,size(xe)))
shading interp
cscale
